"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Workstation
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Interface-Graphics'
!

Workstation comment:'

COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

this class is only here, to get an instance of XWorkstation
named Display - this cannot be done in XWorkstation since Display
is defined in X.h/Xlib.h -- sigh

$Header: /cvs/stx/stx/libview/Attic/Workstat.st,v 1.6 1994-01-08 17:09:27 claus Exp $
written spring/summer 89 by claus
'!

Smalltalk at:#Display      put:nil!
Smalltalk at:#ModalDisplay put:nil!

!Workstation class methodsFor:'initialization'!

initialize
    |displayName workstationType|

    "initialize the default display - this must be done only once"

    Display isNil ifTrue:[
        GLXWorkstation notNil ifTrue:[
            workstationType := GLXWorkstation.
        ] ifFalse:[
            workstationType := XWorkstation
        ].

        workstationType notNil ifTrue:[
            "look for a '-display xxx' argument"
            1 to:(Arguments size - 1) do:[:i |
                ((Arguments at:i) = '-display') ifTrue:[
                    displayName := Arguments at:(i + 1)
                ]
            ].
            "set the corresponding classes ..."

            Display := workstationType basicNew initializeFor:displayName.

"
            Display notNil ifTrue:[
                workstationType == GLXWorkstation ifTrue:[
                    Display serverVendor ~= 'Silicon Graphics' ifTrue:[
                        workstationType := XWorkstation.
                        Display := workstationType basicNew initializeFor:displayName.
                    ]
                ].
            ].
"
            Display notNil ifTrue:[
                DisplayRootView initialize.

                ModalDisplay := workstationType basicNew initializeFor:displayName.
                ModalDisplay keyboardMap:(Display keyboardMap)
            ]
        ] ifFalse:[
            NeXTWorkstation notNil ifTrue:[
                Display := NeXTWorkstation basicNew initialize.
                ModalDisplay := Display
            ]
        ]
    ]
!

reinitialize
    "reinitialize after a snapin"

    Display notNil ifTrue:[
        Display reinitialize.
        (ModalDisplay == Display) ifFalse:[
            ModalDisplay reinitialize
        ]
    ]
! !
